=== debian/changelog ===
nvidia-cuda-toolkit (12.4.1-4build1) questing; urgency=medium

  * No-change rebuild for Qt 6.9.2 private ABI.

 -- Rik Mills <rikmills@kde.org>  Tue, 16 Sep 2025 23:21:10 +0100

nvidia-cuda-toolkit (12.4.1-4) unstable; urgency=medium

  * Use system libsqlite3.so.0.
  * Add separate packages libarrow500 and libparquet500.
  * Build cuda-gdb with -std=gnu17 to fix FTBFS with gcc-15.
    (Closes: #1114235)
  * Add explicit B-D: librdmacm1t64.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 13 Sep 2025 08:35:56 +0200

nvidia-cuda-toolkit (12.4.1-3) unstable; urgency=medium

  * Use a snapshot of openjdk-8-jre (8u462-ga-1).
  * Temporarily skip nvidia-fs build for Linux 6.16+.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 16 Aug 2025 07:04:44 +0200

nvidia-cuda-toolkit (12.4.1-2) unstable; urgency=medium

  * Add clang-17 as supported compiler alternative.
  * Fix parsing CCCL_VERSION.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 21 Jul 2025 03:23:01 +0200

nvidia-cuda-toolkit (12.4.1-1) unstable; urgency=medium

  * New upstream release 12.4.1 (April 2024).
    * Fixes CVE-2024-0072, CVE-2024-0076.  (Closes: #1070177)
      https://nvidia.custhelp.com/app/answers/detail/a_id/5517
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 12 Jun 2025 10:00:21 +0200
