=== debian/control ===
Source: nvidia-cuda-toolkit
Section: non-free/libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
Uploaders:
 Andreas Beckmann <anbe@debian.org>,
 Graham Inggs <ginggs@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-exec,
 quilt,
 chrpath,
Build-Depends-Arch:
 dh-sequence-dkms,
 dh-sequence-python3,
# for cuda-gdb
 bison,
 flex,
 libbabeltrace-dev,
 libdebuginfod-dev,
 libexpat1-dev,
 libipt-dev [amd64],
 liblzma-dev,
 libmpfr-dev,
 libncurses-dev,
 libreadline-dev,
 libsource-highlight-dev,
 libxxhash-dev,
 pkgconf,
 python3-dev,
 python3-setuptools,
 texinfo,
 zlib1g-dev,
# for libcufile
 librdmacm1t64 [!ppc64el] | librdmacm1 [!ppc64el],
# for nsight-compute/nsight-systems
 libcurl4t64 [!ppc64el] | libcurl4 [!ppc64el],
 libdbus-1-3 [!ppc64el],
 libegl1 [!ppc64el],
 libfontconfig1 [!ppc64el],
 libfreetype6 [!ppc64el],
 libgl1 [!ppc64el],
 libgssapi-krb5-2 [!ppc64el],
 libgstreamer-plugins-base1.0-0 [amd64],
 libibmad5 [!ppc64el],
 libibumad3 [!ppc64el],
 libnss3 [!ppc64el],
 libopengl0 [!ppc64el],
 libpfm4 [amd64],
 libqt6wlshellintegration6 [!ppc64el],
 libsm6 [amd64],
 libssh-dev [!ppc64el],
 libucx0 [!ppc64el],
 libwayland-cursor0 [!ppc64el],
 libwayland-egl1 [!ppc64el],
 libxcb-icccm4 [!ppc64el],
 libxcb-image0 [!ppc64el],
 libxcb-keysyms1 [!ppc64el],
 libxcb-randr0 [!ppc64el],
 libxcb-render-util0 [!ppc64el],
 libxcb-shape0 [!ppc64el],
 libxcomposite1 [!ppc64el],
 libxdamage1 [!ppc64el],
 libxfixes3 [!ppc64el],
 libxi6 [!ppc64el],
 libxkbcommon-x11-0 [!ppc64el],
 libxkbfile1 [!ppc64el],
 libxrandr2 [!ppc64el],
 libxtst6 [!ppc64el],
# for nvidia-openjdk-8-jre
 libasound2-dev [!arm64],
 libfreetype-dev [!arm64],
 libgif-dev [!arm64],
 libjpeg-dev (>= 1:0) [!arm64] | libjpeg62-dev [!arm64],
 liblcms2-dev [!arm64],
 libpcsclite-dev [!arm64],
 libpng-dev [!arm64],
 libpulse-dev [!arm64],
 libxi-dev [!arm64],
 libxrender-dev [!arm64],
 libxtst-dev [!arm64],
Rules-Requires-Root: no
Standards-Version: 4.7.2
Homepage: https://developer.nvidia.com/cuda-zone
Vcs-Browser: https://salsa.debian.org/nvidia-team/nvidia-cuda-toolkit
Vcs-Git: https://salsa.debian.org/nvidia-team/nvidia-cuda-toolkit.git
XS-Autobuild: yes

Package: nvidia-cuda-toolkit
Section: non-free/devel
Architecture: amd64 ppc64el arm64
Depends:
 ${nvidia-profiler:eq:Version} [${cuda:arch:has-nvidia-profiler}],
 ${nvidia-cuda-dev:eq:Version},
 ${nvidia-opencl-dev:eq:Version} | opencl-dev,
 g++-${cuda:gcc:DefaultVersion}
 | g++-13
 | clang-17
 | g++-12
 | clang-16
 | clang-15
 | clang-14
 | g++-11
 | clang-13
 | clang-12
 | g++-10
 | clang-11
 | clang-10
 | g++-9
 | clang-9
 | g++-8
 | clang-8
 | clang-7
 | g++-7
 | clang (<< 1:18~)
 | g++-6
 ,
 ${shlibs:Depends}, ${misc:Depends},
Recommends:
 nvidia-cuda-toolkit-doc (= ${source:Version}),
 ${nvidia-cuda-gdb:eq:Version},
 ${nvidia-visual-profiler:eq:Version} [${cuda:arch:has-nvidia-visual-profiler}],
 ${nsight-compute:eq:Version},
 ${nsight-systems:eq:Version},
Suggests:
 ${package:driver},
Breaks:
 nvidia-cuda-doc (<< 10.2.89-3),
Description: NVIDIA CUDA development toolkit
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 This package contains the nvcc compiler and other tools needed for building
 CUDA applications.
 .
 Running CUDA applications requires a supported NVIDIA GPU and the NVIDIA
 driver kernel module.

Package: nvidia-cuda-toolkit-gcc
Section: non-free/devel
Architecture: amd64 ppc64el arm64
Depends:
 g++-${cuda:gcc:DefaultVersion},
 ${nvidia-cuda-toolkit:eq:Version},
 ${misc:Depends},
Description: NVIDIA CUDA development toolkit (GCC compatibility)
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 This package provides the /usr/bin/cuda-gcc, /usr/bin/cuda-g++ symlinks to
 simplify building packages that need to be built with a CUDA-compatible
 compiler.
 .
 This package ensures a deterministic nvcc/gcc combination is used by default
 and is therefore recommended to be used as build dependency for all source
 packages needing nvcc for building.

Package: nvidia-cuda-toolkit-doc
Section: non-free/doc
Architecture: all
Depends:
 libjs-html5shiv,
 libjs-jquery,
 ${misc:Depends}
Breaks:
 nvidia-cuda-doc (<< 10.2.89-3),
Replaces:
 nvidia-cuda-doc (<< 10.2.89-3),
Suggests:
 nvidia-cuda-samples (>= ${cuda:Version:Major}),
Homepage: https://docs.nvidia.com/cuda
Description: NVIDIA CUDA and OpenCL documentation
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 OpenCL (Open Computing Language) is a multi-vendor open standard for
 general-purpose parallel programming of heterogeneous systems that include
 CPUs, GPUs and other processors.
 .
 Note that CUDA documentation is no longer bundled with CUDA toolkit releases.
 Visit https://docs.nvidia.com/cuda for the latest documentation on CUDA.

Package: nvidia-cuda-gdb
Section: non-free/devel
Architecture: amd64 ppc64el arm64
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: nvidia-cuda-toolkit-doc (= ${source:Version})
Description: NVIDIA CUDA Debugger (GDB)
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 This package contains the cuda-gdb debugger.

Package: nvidia-profiler
Section: non-free/devel
Architecture: amd64 ppc64el
Depends:
 ${libaccinj64-:eq:Version},
 ${libcuinj64-:eq:Version},
 ${shlibs:Depends}, ${misc:Depends}
Suggests:
 nvidia-cuda-toolkit,
Description: NVIDIA Profiler for CUDA and OpenCL
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 OpenCL (Open Computing Language) is a multi-vendor open standard for
 general-purpose parallel programming of heterogeneous systems that include
 CPUs, GPUs and other processors.
 .
 This package contains the nvprof profiler.

Package: nvidia-openjdk-8-jre
Section: non-free/java
Architecture: amd64 ppc64el
Depends:
 libatk-wrapper-java-jni (>= 0.33.3-9~),
 ${shlibs:Depends}, ${misc:Depends}
Conflicts:
 openjdk-8-jre-headless,
 openjdk-8-jre,
Replaces:
 openjdk-8-jre-headless,
 openjdk-8-jre,
Homepage: http://openjdk.java.net/
Description: Obsolete OpenJDK Java runtime, for NVIDIA applications
 Full Java runtime environment - needed for executing Java GUI and Webstart
 programs, using Hotspot JIT.
 .
 This package provides OpenJDK-8 JRE binaries built on Debian for use with
 the NVIDIA CUDA Toolkit. This obsolete version is needed for
 nvidia-visual-profiler.

Package: nvidia-visual-profiler
Section: non-free/devel
Architecture: amd64 ppc64el
Depends:
 ${jre:Depends},
 libgtk2.0-0,
 ${nvidia-profiler:eq:Version} [${cuda:arch:has-nvidia-profiler}],
 ${perl:Depends},
 ${shlibs:Depends}, ${misc:Depends}
Recommends: nvidia-cuda-toolkit-doc (= ${source:Version}),
Homepage: https://developer.nvidia.com/nvidia-visual-profiler
Description: NVIDIA Visual Profiler for CUDA and OpenCL
 The NVIDIA Visual Profiler is a cross-platform performance profiling tool
 that delivers developers vital feedback for optimizing CUDA C/C++ and OpenCL
 applications.

Package: nsight-compute
Section: non-free/devel
Architecture: amd64 ppc64el arm64
Depends:
 libjs-sphinxdoc,
 node-html5shiv,
 sphinx-rtd-theme-common,
 ${nsight-compute-target:eq:Version},
 ${libparquet:eq:Version} [amd64],
 libssh-4 [!ppc64el],
 ${python3:Depends},
 ${shlibs:Depends}, ${misc:Depends}
Homepage: https://developer.nvidia.com/nsight-compute
Description: NVIDIA Nsight Compute
 NVIDIA Nsight Compute is an interactive kernel profiler for CUDA applications.
 It provides detailed performance metrics and API debugging via a user
 interface and command line tool. In addition, its baseline feature allows
 users to compare results within the tool. Nsight Compute provides a
 customizable and data-driven user interface and metric collection and can be
 extended with analysis scripts for post-processing results.

Package: nsight-compute-target
Section: non-free/devel
Architecture: amd64 ppc64el arm64
Multi-Arch: same
Depends:
 ${shlibs:Depends}, ${misc:Depends}
Breaks:
 nsight-compute (<< 10.2.89-3),
Homepage: https://developer.nvidia.com/nsight-compute
Description: NVIDIA Nsight Compute (target specific libraries)
 NVIDIA Nsight Compute is an interactive kernel profiler for CUDA applications.
 It provides detailed performance metrics and API debugging via a user
 interface and command line tool. In addition, its baseline feature allows
 users to compare results within the tool. Nsight Compute provides a
 customizable and data-driven user interface and metric collection and can be
 extended with analysis scripts for post-processing results.
 .
 This package contains the target specific libraries.

Package: nsight-systems
Section: non-free/devel
Architecture: amd64 ppc64el arm64
Depends:
 libjs-sphinxdoc,
 node-html5shiv,
 sphinx-rtd-theme-common,
 ${nsight-systems-target:eq:Version},
 ${libparquet:eq:Version},
 libssh-4 [!ppc64el],
 ${python3:Depends},
 ${shlibs:Depends}, ${misc:Depends}
Recommends:
 ${nvidia-profiler:eq:Version} [${cuda:arch:has-nvidia-profiler}],
Homepage: https://developer.nvidia.com/nsight-systems
Description: NVIDIA Nsight Systems
 NVIDIA Nsight Systems is a system-wide performance analysis tool designed to
 visualize an application’s algorithms, help you identify the largest
 opportunities to optimize, and tune to scale efficiently across any quantity
 or size of CPUs and GPUs; from large server to smallest SoCs.

Package: nsight-systems-target
Section: non-free/devel
Architecture: amd64 ppc64el arm64
Multi-Arch: same
Depends:
 python3:any,
 ${shlibs:Depends}, ${misc:Depends}
Breaks:
 nsight-systems (<< 10.2.89-3),
Homepage: https://developer.nvidia.com/nsight-systems
Description: NVIDIA Nsight Systems (target specific libraries)
 NVIDIA Nsight Systems is a system-wide performance analysis tool designed to
 visualize an application’s algorithms, help you identify the largest
 opportunities to optimize, and tune to scale efficiently across any quantity
 or size of CPUs and GPUs; from large server to smallest SoCs.
 .
 This package contains the target specific libraries.

Package: nvidia-cuda-dev
Section: non-free/libdevel
Architecture: amd64 ppc64el arm64
Multi-Arch: same
Depends:
 ${libcudart:eq:Version},
 ${libaccinj64-:eq:Version} [${cuda:arch:has-nvidia-profiler}],
 ${libcuinj64-:eq:Version} [${cuda:arch:has-nvidia-profiler}],
 ${libnvrtc:eq:Version},
 ${libnvrtc-builtins:eq:Version},
 ${libnvtoolsext:eq:Version},
 ${libnvvm:eq:Version},
 ${libcublas:eq:Version},
 ${libcublaslt:eq:Version},
 ${libnvblas:eq:Version},
 ${libcufft:eq:Version},
 ${libcufftw:eq:Version},
 ${libcurand:eq:Version},
 ${libcusolver:eq:Version},
 ${libcusolvermg:eq:Version},
 ${libcusparse:eq:Version},
 ${libnppc:eq:Version},
 ${libnppial:eq:Version},
 ${libnppicc:eq:Version},
 ${libnppidei:eq:Version},
 ${libnppif:eq:Version},
 ${libnppig:eq:Version},
 ${libnppim:eq:Version},
 ${libnppist:eq:Version},
 ${libnppisu:eq:Version},
 ${libnppitc:eq:Version},
 ${libnpps:eq:Version},
 ${libnvfatbin:eq:Version},
 ${libnvjitlink:eq:Version},
 ${libnvjpeg:eq:Version},
 ${libcupti-dev:eq:Version},
 ${libnvidia-ml-dev:eq:Version},
 libcu++-dev (>= ${cccl:Version}~),
 libcub-dev (>= ${cccl:Version}~),
 libthrust-dev (>= ${cccl:Version}~),
 ${package:libcuda1},
 ${misc:Depends}
Recommends:
 libgl-dev,
 libvdpau-dev,
 libnvcuvid1,
Breaks:
 libcuda1 (<< ${nvidia:MinVersion}),
Description: NVIDIA CUDA development files
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
