=== debian/watch ===
version=4
opts=searchmode=plain https://developer.nvidia.com/cuda-toolkit-archive CUDA.Toolkit.([0-9.]+)
